//Google Site Indexer by Jeff Stewart (jeffball55)
//Google Site Indexer uses the google site operator, the robots.txt file, and the inurl operator to attempt to
//	Create a directory listing
//This software is free and open source, the only thing asked is if you reuse the code you give
//	credit where credit is due.

//Credit goes to Ren Nyffenegger for creating the socket class which this application uses to access google
//	and the target website

//Bug reports, suggestions, comments, and questions can be sent to me at jeffball55@hotmail.com or posted to
//the coders section of http://johnny.ihackstuff.com in the appropriate post (the one for Google Site Indexer)

#include "Socket.h"

#include <iostream>
#include <fstream>
#include <string>
#include <math.h>
#include <windows.h>   // needed for get tick count function to seed the random generator


//First GSI sends a query for the site:website and collects all the website filenames
//next it retrieves the robots.txt and trys to enumerate those directories with inurl:directory


using namespace std;

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////Global variables///////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

   struct aResult
   {
      aResult* brother;
	  aResult* sister;
	  aResult* father;
	  aResult* son;
	  string name;
	  string fathername;
	  int depth; //starts at 0.
	  int index;
   };

   const int maxresults = 1000;

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////Function Prototypes////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


void PrintTheDirectory(int, ofstream &, struct aResult results[], int, int);
void PutInList(struct aResult results[], string pretemp, string temp, int length);
void NullTheList(struct aResult results[]);
bool AlreadyInList(struct aResult results[], string pretemp, string temp, int length);


///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////Functions//////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


int main(int argc, char *argv[] ) {

	const char quotez = 34;  //used to represent a " in the help message

	if(argc < 2 || strcmp(argv[1],"/h") == 0 || strcmp(argv[1],"help") == 0 || strcmp(argv[1],"/?") == 0)
	{ //print a nice little help message
		cout << "\nUsage for Google Site Indexer (GSI): \n"
		<< " GSI Website [flags] \n"
		<< "  Avaliable flags:\n"
		<< "   -t n \n"
		<< "     waits n milliseconds between searches \n"
		<< "   -o outputfile \n"
		<< "     specify an output file \n"
		<< "   -r \n"
		<< "     don't send the robots.txt query \n"
		<< "   -s \n"
		<< "     don't sent the site: query \n"
		<< " Example:\n"
		<< "  GSI www.google.com -t 100 \n"
		<< "   Creates a directory listing for www.google.com and waits\n"
		<< "    1/10 a second between searches \n";
			
		return 0;
	}

	srand(GetTickCount()); 	

	int time = 0; //used to delay the search

    SocketClient s("www.google.com", 80);

	string outfile = "GSI_Results.html";
	bool sendrobotstxt = true;
	bool sendsite = true;

	for(int i = 1; i < argc; i++)
	{
		if(strcmp(argv[i],"-t") == 0) //delay the search (I never used it but added it any way)
			time = atoi(argv[i+1]);
		else if(strcmp(argv[i],"-o") == 0) //specify an output for the searches
			outfile = argv[i+1];		   //useful for scripting so you don't overwrite previous output
		else if(strcmp(argv[i],"-r") == 0)
			sendrobotstxt = false;
		else if(strcmp(argv[i],"-s") == 0)
			sendsite = false;
	}
	
	ofstream htmlfile(outfile.c_str());// open the output file
	
	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	////////////////////////////////////////////////////////////////////////////////////////
	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	int pos ,oldpos, pos2, oldpos2; 
	int indexer = 1; //indexer holds the number of items in the results struct
	int pagenum = 0; //used to hold the number of results
	char buffer[150];
	string apage = "";// holds an entire results page
	string link = "";// holds a single link at a time
	struct aResult results[maxresults];
	struct aResult tempresult;
	string temp, pretemp;

	NullTheList(results);

	results[0].name = argv[1];
	results[0].depth = 0;
	results[0].fathername = "ROOT DIRECTORY";

	string getlines = "GET /search?q=site%3A";
	string searchstring = argv[1];
		
	for(i = 0; i < searchstring.length(); i++)
	{
		if(searchstring[i] == 39)  //change ' to %22 which is hex for "
		{
			searchstring[i] = '%';
			searchstring.insert(i+1,"22");
		}
		else if(searchstring[i] == ' ') //change spaces to +'s
		{
			searchstring[i] = '+';
		}
	}
		
	htmlfile << "<title> Google Site Indexer directory listing for: " << argv[1] << "</title>\n"; //add an html title to the page
	htmlfile.flush();

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////Sending site operator query///////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	if(sendsite)
	{
		cout << "Sending site operator query \n"; 

		while(pagenum == 0 || (apage.find("<TITLE>302 Moved</TITLE>",0) == string::npos && apage.find("Result&nbsp;Page:&nbsp;</font>",0) != string::npos))
		{//continue while there are more results
			apage = "";			
			sprintf(buffer, "%d", pagenum);
			pagenum+=100;

			if(pagenum > 1000) //if we have 1000 results go to the next search
				goto bottom4;

			cout << "Getting " << pagenum-100 << "-" << pagenum << " results\n";

			getlines = getlines + searchstring + "&num=100&start=" + buffer;				
			getlines = getlines + "&filter=0 HTTP/1.1"; //finish the get request


			s.SendLine(getlines);
			s.SendLine("Host: www.google.com/"); //send the get request
			s.SendLine("");

			while (true) 
			{//continue adding data into apage until the end of the page or a 403 error happens
				string l = s.ReceiveLine();
				if (l.empty())
					goto end;					
						
				apage +=  l; 

				if(l.find("</html>",0) != string::npos) //end of page
					goto end;
				else if(apage.find("<TITLE>302 Moved</TITLE>",0) != string::npos) //page is now forbidden
					goto bottom;
			}
	end:
			pos = 0;
			oldpos = 0;
			while(apage.find("href=",oldpos) != string::npos)
			{ //get all the links
				bool questionmark = false;
				bool firstrun = true;
				bool alreadyin = false;

				pos = apage.find("href=",oldpos);
				link = apage.substr(pos+6,(apage.find('>',pos)-1)-(pos+6));	

				if((link.substr(0,6).find("http",0) != string::npos || link.substr(0,6).find("ftp",0) != string::npos) && link.find("google.com",0) == string::npos && link.find("/url?",0) == string::npos && link.find("search?q=cache",0) == string::npos && link.find("/iclk?sa",0) == string::npos && link.find("related:",0) == string::npos && link.find("/search?",0) == string::npos && link.find("?sa=X&oi=dict",0) == string::npos && link.find("onmouseover=",0) == string::npos && link.find("preferences?q=",0) == string::npos && link.find("advanced_search?q=",0) == string::npos)
				{//at this point link holds a results link from a google search
					pretemp = argv[1];

					pos2 = 8;
					oldpos2 = 8;
					while(link.find("/",oldpos2) != string::npos || link.find("?",oldpos2) != string::npos)
					{
						if(link.find("/",oldpos2) != string::npos && link.find("?",oldpos2) != string::npos)
						{//both a / and ? are still in the link
							if(link.find("/",oldpos2) < link.find("?",oldpos2))
								pos2 = link.find("/",oldpos2);
							else
							{
								pos2 = link.find("?",oldpos2);
								questionmark = true;
							}
						}
						else if(link.find("?",oldpos2) != string::npos)
						{//just a ? is left
							pos2 = link.find("?",oldpos2);
							questionmark = true;
						}
						else
						{//just a / is left
							pos2 = link.find("/",oldpos2);
						}
						temp = link.substr(oldpos2,(pos2)-(oldpos2)); //temp now holds the last part of the url
						
						if(!firstrun)
						{
							if(!AlreadyInList(results, pretemp, temp, indexer) && indexer < maxresults - 1)
							{
								PutInList(results, pretemp, temp, indexer);
								indexer++;
							}
						}

						if(questionmark)
							goto bottom2;

						if(!firstrun)
							pretemp = temp;
						else
							pretemp = argv[1];

						oldpos2 = pos2 +1;
						firstrun = false;
					}
					temp = link.substr(oldpos2);
					if(temp != "") //get the last url if the last seperator wasn't a question mark
					{
						if(!AlreadyInList(results, pretemp, temp, indexer) && indexer < maxresults - 1)
						{
							PutInList(results, pretemp, temp, indexer);
							indexer++;
						}
					}
				}
			bottom2:  //get ready for the next link
				oldpos = pos +1;
				questionmark = false;
				firstrun = true;
			}
		bottom: //get ready for the more results from the next 100 results
			getlines = "GET /search?q=site%3A";
			Sleep(time);
		}
	}
	bottom4: //finished the site: search
	

/////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////sending robots.txt///////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////////////

	if(sendrobotstxt)
	{
		cout << "Sending robots.txt request \n"; 
		apage = "";			

		temp = argv[1];
		SocketClient mm(temp, 80);

		getlines = "GET /robots.txt HTTP/1.0";
		mm.SendLine(getlines);
		getlines = "Host: " + results[0].name;// + "/"; /////////send the get request
		mm.SendLine(getlines); 
		mm.SendLine("");

		string l;

		while (true) 
		{//continue adding data into apage until the end of the page or a 403 error happens
			l = mm.ReceiveLine();
			if (l.empty())
				goto end2;					
							
			apage +=  l;
		
			if(apage.find("<html>",0) != string::npos) //page isn't a robots.txt file
				goto bottom3;
		}
		end2:
		pos = 0;
		oldpos = 0;


		while(apage.find("Disallow: /",oldpos) != string::npos)
		{ //get all the disallow directories
			bool alreadyin = false;
			bool questionmark = false;

			
			pos = apage.find("Disallow: /",oldpos);
			if(apage.find("Allow",pos+1) != string::npos && apage.find("Disallow") != string::npos)
			{
				if(apage.find("Allow",pos+1) < apage.find("Disallow",pos+1))
					link = apage.substr(pos+11,(apage.find("Allow",pos+1)-1)-(pos+10));	
				else
					link = apage.substr(pos+11,(apage.find("Disallow",pos+1)-1)-(pos+10));	
			}
			else if(apage.find("Allow",pos+1) != string::npos)
			{
				link = apage.substr(pos+11,(apage.find("Allow",pos+1)-1)-(pos+10));	
			}
			else
			{
				link = apage.substr(pos+11,(apage.find("Disallow",pos+1)-1)-(pos+10));	
			}

			pretemp = argv[1];
			pos2 = 0;
			oldpos2 = 0;

			while(link.find("/",oldpos2) != string::npos || link.find("?",oldpos2) != string::npos)
			{
				if(link.find("/",oldpos2) != string::npos && link.find("?",oldpos2) != string::npos)
				{//both a / and ? are still in the link
					if(link.find("/",oldpos2) < link.find("?",oldpos2))
						pos2 = link.find("/",oldpos2);
					else
					{
						pos2 = link.find("?",oldpos2);
						questionmark = true;
					}
				}
				else if(link.find("?",oldpos2) != string::npos)
				{//just a ? is left
					pos2 = link.find("?",oldpos2);
					questionmark = true;
				}
				else
				{//just a / is left
					pos2 = link.find("/",oldpos2);
				}
				temp = link.substr(oldpos2,(pos2)-(oldpos2));
					

				if(!AlreadyInList(results, pretemp, temp, indexer) && indexer < maxresults - 1)
				{
					PutInList(results, pretemp, temp, indexer);
					indexer++;
				}

				if(questionmark)
					goto bottom7;

				oldpos2 = pos2 +1;
				pretemp = temp;
			}
			temp = link.substr(oldpos2);
			if(temp != "") //get the last url if the last seperator wasn't a question mark
			{
				if(!AlreadyInList(results, pretemp, temp, indexer) && indexer < maxresults - 1)
				{
					PutInList(results, pretemp, temp, indexer);
					indexer++;
				}
			}
		bottom7:  //get ready for the next link
			oldpos = pos +1;
			pretemp = argv[1];
			questionmark = false;
		}

		pos = 0;
		oldpos = 0;

		while(apage.find("Allow: /",oldpos) != string::npos)
		{ //get all the Allow directories
			bool alreadyin = false;
			bool questionmark = false;

			pos = apage.find("Allow: /",oldpos);
			if(apage.find("Allow",pos+1) != string::npos && apage.find("Disallow") != string::npos)
			{
				if(apage.find("Allow",pos+1) < apage.find("Disallow",pos+1))
					link = apage.substr(pos+8,(apage.find("Allow",pos+1)-1)-(pos+7));	
				else
					link = apage.substr(pos+8,(apage.find("Disallow",pos+1)-1)-(pos+7));	
			}
			else if(apage.find("Allow",pos+1) != string::npos)
			{
				link = apage.substr(pos+8,(apage.find("Allow",pos+1)-1)-(pos+7));	
			}
			else
			{
				link = apage.substr(pos+8,(apage.find("Disallow",pos+1)-1)-(pos+7));	
			}

			pretemp = argv[1];
			pos2 = 0;
			oldpos2 = 0;

			while(link.find("/",oldpos2) != string::npos || link.find("?",oldpos2) != string::npos)
			{
				if(link.find("/",oldpos2) != string::npos && link.find("?",oldpos2) != string::npos)
				{//both a / and ? are still in the link
					if(link.find("/",oldpos2) < link.find("?",oldpos2))
						pos2 = link.find("/",oldpos2);
					else
					{
						pos2 = link.find("?",oldpos2);
						questionmark = true;
					}
				}
				else if(link.find("?",oldpos2) != string::npos)
				{//just a ? is left
					pos2 = link.find("?",oldpos2);
					questionmark = true;
				}
				else
				{//just a / is left
					pos2 = link.find("/",oldpos2);
				}
				temp = link.substr(oldpos2,(pos2)-(oldpos2));
					

				if(!AlreadyInList(results, pretemp, temp, indexer) && indexer < maxresults - 1)
				{
					PutInList(results, pretemp, temp, indexer);
					indexer++;
				}

				if(questionmark)
					goto bottom8;

				oldpos2 = pos2 +1;
				pretemp = temp;
			}
			temp = link.substr(oldpos2);
			if(temp != "") //get the last url if the last seperator wasn't a question mark
			{
				if(!AlreadyInList(results, pretemp, temp, indexer) && indexer < maxresults - 1)
				{
					PutInList(results, pretemp, temp, indexer);
					indexer++;
				}
			}
		bottom8:  //get ready for the next link
			oldpos = pos +1;
			pretemp = argv[1];
			questionmark = false;
		}
	bottom3:
	mm.Close();
	}

	cout << "Printing the Directory Listing\n";

	PrintTheDirectory(indexer,htmlfile,results,0, 0);  //print the directory structure


	htmlfile.close();
	return 0;
}


////////////////////////////////////////////////////////////////////////////////////////////////////////////////

//Recursively prints the directory structure by searching fdlinks for directories and printing the corresponding
void PrintTheDirectory(int length, ofstream &htmlfile, struct aResult results[], int i, int depthused)
{
	struct aResult* tempresult;
	string link = "";
	
	tempresult = &results[i];
	while(tempresult->father != NULL)
	{
		if(tempresult == &results[i])
			link = tempresult->name;
		else
			link = tempresult->name + "/" + link;
		tempresult = tempresult->father;
	}
	link = "http://" + tempresult->name + "/" + link;

	htmlfile << "<ul> <a href=" << link << ">" << results[i].name << "</a>";
	if(results[i].son != NULL)
	{
		PrintTheDirectory(length, htmlfile, results,results[i].son->index, depthused);
	}
	htmlfile << " </ul>\n";

	tempresult = &results[i];
	if(depthused <= results[i].depth)
	{
		depthused = results[i].depth + 1;
		while(tempresult->brother != NULL)
		{
			PrintTheDirectory(length, htmlfile, results, tempresult->brother->index,depthused);
			tempresult = tempresult->brother;
		}
	}

	return;
}

//Put a result in the list
void PutInList(struct aResult results[], string pretemp, string temp, int length)
{
	int x;
	bool found = false;
	for(x = 0; x < length; x++)
	{
		if(pretemp == results[x].name)
		{
			found = true;
			break;
		}
	}
	if(found)
	{
		results[length].father = &results[x];
		results[length].fathername = pretemp;
		results[length].name = temp;
		results[length].depth = results[x].depth + 1;
		
		if(results[x].son == NULL)
		{
			results[x].son = &results[length];
		}
		else
		{
			aResult* tempresult;
			tempresult = results[x].son;
			while(tempresult->brother != NULL)
			{
				tempresult = tempresult->brother;
			}
			tempresult->brother = &results[length];
			results[length].sister = tempresult;
		}
	}
}

//Null the list out
void NullTheList(struct aResult results[])
{
	for(int x = 0; x < maxresults; x++)
	{
		results[x].brother = NULL;
		results[x].sister = NULL;
		results[x].son = NULL;
		results[x].father = NULL;
		results[x].name = "";
		results[x].fathername = "";
		results[x].depth = -1;
		results[x].index = x;
	}

}

bool AlreadyInList(struct aResult results[], string pretemp, string temp, int length)
{
	bool found = false;
	for(int x = 0; x < length && !found; x++)
	{
		if(results[x].name == temp && results[x].fathername == pretemp)
			found = true;
	}
	return found;
}